SystemOrganization addCategory: #'GT-Debugger-EventRecorder'!

Object subclass: #GLMRecorderEvent
	instanceVariableNames: 'timestamp info'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder'!

GLMRecorderEvent subclass: #GLMRecorderBrowserClosingEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder'!

!GLMRecorderBrowserClosingEvent class methodsFor: 'as yet unclassified' stamp: 'AndreiChis 1/29/2016 14:58'!
fromAnnouncement: anAnnouncement

	^ self new fromAnnouncement: anAnnouncement! !

!GLMRecorderBrowserClosingEvent methodsFor: 'initialization' stamp: 'AndreiChis 1/29/2016 15:16'!
fromAnnouncement: anAnnouncement
	super fromAnnouncement: anAnnouncement.

	anAnnouncement presentation window ifNotNil: [ :aWindow |
		self infoAt: #windowHash put: aWindow identityHash ]
	! !

!GLMRecorderEvent methodsFor: 'as yet unclassified' stamp: 'AndreiChis 1/29/2016 14:58'!
fromAnnouncement: anAnnouncement
! !

!GLMRecorderEvent methodsFor: 'as yet unclassified' stamp: 'AndreiChis 1/29/2016 14:58'!
infoAt: key put: value
	info ifNil: [ info := Dictionary new ].
	^ info at: key put: value! !

Object subclass: #GTDebuggerRecorderEvent
	instanceVariableNames: 'timestamp info'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder'!

GTDebuggerRecorderEvent subclass: #GTDebuggerDebugActionEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder'!

!GTDebuggerDebugActionEvent methodsFor: 'initialization' stamp: 'RogerStebler 2/29/2016 15:11'!
asDebugActionFor: aDebugger
	| actionClass |
	actionClass := (info at: #debugActionClass) asSymbol asClass.
	(actionClass respondsTo: #gtGlobalDebuggingActionFor:) ifTrue: [
		^ actionClass gtGlobalDebuggingActionFor: aDebugger ].
	^ nil! !

!GTDebuggerDebugActionEvent methodsFor: 'initialization' stamp: 'RogerStebler 2/24/2016 19:40'!
fromDebugAction: aDebugAction
	self infoAt: #debugActionClass put: aDebugAction class name.
	"self addWindowHashFor: aDebugAction debugger"
	! !

!GTDebuggerRecorderEvent class methodsFor: 'instance creation' stamp: 'AndreiChis 1/29/2016 14:28'!
fromAnnouncement: anAnnouncement

	^ self new fromAnnouncement: anAnnouncement! !

!GTDebuggerRecorderEvent methodsFor: 'as yet unclassified' stamp: 'AndreiChis 1/29/2016 15:36'!
addWindowHashFor: aPresentation

	aPresentation window ifNotNil: [ :aWindow |
		self infoAt: #windowHash put: aWindow identityHash ]! !

!GTDebuggerRecorderEvent methodsFor: 'initialization' stamp: 'AndreiChis 1/29/2016 14:28'!
fromAnnouncement: anAnnouncement
! !

!GTDebuggerRecorderEvent methodsFor: 'as yet unclassified' stamp: 'AndreiChis 1/29/2016 14:42'!
infoAt: key put: value
	info ifNil: [ info := Dictionary new ].
	^ info at: key put: value! !

GTDebuggerRecorderEvent subclass: #GTDebuggerRecorderOpenEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder'!

!GTDebuggerRecorderOpenEvent methodsFor: 'as yet unclassified' stamp: 'AndreiChis 1/29/2016 15:37'!
fromDebugger: aDebugger

	self infoAt: #debuggerClass put: aDebugger class name.
	self addWindowHashFor: aDebugger! !

GTEventCollector subclass: #GTDebuggerEventCollector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder'!

!GTDebuggerEventCollector methodsFor: 'as yet unclassified' stamp: 'AndreiChis 1/29/2016 15:58'!
initialize
	super initialize.	
	recordedEvents := SharedQueue  new.
	creationTime := DateAndTime now.! !

!GTDebuggerEventCollector methodsFor: 'as yet unclassified' stamp: 'AndreiChis 1/29/2016 14:16'!
linkToDebugger: aDebugger

	aDebugger announcer weak when: Announcement send: #recordAnnouncement: to: self! !

!GTDebuggerEventCollector methodsFor: 'as yet unclassified' stamp: 'RogerStebler 2/24/2016 19:39'!
recordAnnouncement: anAnnouncement
	"Privacy sendDiagnosticsAndUsageData ifFalse: [ ^ self ]."	
	(anAnnouncement respondsTo: #asRecorderEvent) ifTrue: [	
		self add: anAnnouncement asRecorderEvent ]! !

!GTDebuggerEventCollector methodsFor: 'as yet unclassified' stamp: 'AndreiChis 1/29/2016 14:46'!
recordDebuggerOpenEventFor: aDebugger
	"Privacy sendDiagnosticsAndUsageData ifFalse: [ ^ self ]."	
	self add: (GTDebuggerRecorderOpenEvent new fromDebugger: aDebugger)! !

!GTDebuggerEventCollector methodsFor: 'as yet unclassified' stamp: 'RogerStebler 2/29/2016 15:23'!
runDebugActionsIn: aDebugger
	| action event events |
	
	events := recordedEvents copy.
	[events isEmpty] whileFalse: [
		event := events next.
		(event class == GTDebuggerDebugActionEvent) ifTrue: [
			action := event asDebugActionFor: aDebugger.
			(action isNil or: [action class == RedoDebugAction]) ifFalse: [
				action executeAction.
				aDebugger updateBrowser
			].
		].
	].
	! !

!DebugAction methodsFor: '*GT-Debugger-EventRecorder' stamp: 'AndreiChis 1/29/2016 14:34'!
asRecorderEvent

	^ GTDebuggerDebugActionEvent new fromDebugAction: self! !

!DebugActionExecuted methodsFor: '*GT-Debugger-EventRecorder' stamp: 'AndreiChis 1/29/2016 14:31'!
asRecorderEvent

	^ debuggingAction asRecorderEvent fromAnnouncement: self! !

!GLMBrowserClosing methodsFor: '*GT-Debugger-EventRecorder' stamp: 'AndreiChis 1/29/2016 15:00'!
asRecorderEvent

	^ GLMRecorderBrowserClosingEvent fromAnnouncement: self! !
